/* XBBS Library Utility (1.09) for Zoo-archived Text File Libraries */
/* Copyright 1988/89/90 by M. Kimes -- All Rights Reserved */
/* Modified source code or executable may not be distributed */


#include "library.h"



/*-Function declarations------------------------------------------------*/


extern int    pascal list_zoo (word secnum,char printit,char justheader,char *searchfor);
extern void   pascal free_docs(void);
extern void   pascal hitreturn(void);
extern void   pascal cls(void);
extern char   pascal inkey (void);
extern char   pascal carrchk (void);
extern char   pascal fossil (char function, char arg);
extern char   pascal printm (char *text);
extern void   cdecl  deinitialize (void);
extern char * pascal genin (char length,char password,char caps,char hot,char type);
extern char * pascal fidodate (void);
extern long   pascal getxbbstime(void);
extern char   pascal specialkey(char);
extern int    cdecl  break_handler(void);
extern char   pascal readtext(char *);
extern char   pascal printg(char *);
extern char   pascal skip_blanks(FILE *fp);
extern void   pascal chat(void);
extern void   pascal printinfo(void);
extern word   pascal load_sections(void);
extern void   pascal list_sections(void);
extern char * pascal lstrip(char *);
extern void   pascal readfile(word,word);
extern word   pascal security(void);
extern void   pascal full_list(char *keyword);
extern void   pascal quick_list(void);
extern void   pascal printmenu(void);
extern char * pascal rstrip(char *);
extern int    cdecl  printfm(char *,...);
extern char * pascal stristr(char *,char *);
extern void   pascal maintenance(void);
extern void   pascal print_maint_menu(void);
extern int    pascal name_match (char *mask,char *name);
extern void   pascal bios_scroll(int tx, int ty, int bx, int by, int attr, char dir, int howmany);
extern void   pascal status(void);
extern int    pascal trim_section (word secnum,word howmany);
int    pascal common (int func);

/*- Global variables ----------------------------------------*/


#define MAXFILES    4096
#define MAXSECTIONS 1024
#define MAXPTRS     1024

extern char  *section[MAXSECTIONS];
extern char  *document[MAXFILES];
extern word   numsecs;
extern word   numfiles;
extern char   graphics;
extern char   pauser;
extern word   lines;
extern long   timelimit;
extern word   baud;
extern char   numlines;
extern word   seclvl;
extern long   startt;
extern char   commport;
extern union  REGS rg;
extern char   home_dir[128];
extern char   lib_dir[128];
extern char   logfile[133];
extern char   jumped;
extern char   username[36];
extern char   width;
extern char   fast;
extern char   chatting;
extern char   chatted;
extern char   secfile[99];
extern char   quick;
extern char   full;
extern char   grapharea;
extern char   sysmode;
extern char   menus;
extern char   reader[99];
extern char   maint;
extern char   node;
extern word   cursec;
extern char   tmpin[13];
extern char   tmpout[13];
extern char   nowatchdog;
extern char   lastextracted[13];
extern char   maintmenu;
extern char   libmenu;



int pascal common (int func) {

    char *p;
    word x,y;
    char s[16];
    char temp;
    static char keyword[81]="";

    switch(func) {
        case 'F':   printm("Do you want complete file/section lists? (Y/n) ");
                    if (*genin(1,0,1,1,YESNO)!='N') full=0;
                    else full=1;
                    printm("\r\nDo you want a short list at Read and Jump? (Y/n) ");
                    if (*genin(1,0,1,1,YESNO)!='N') quick=0;
                    else quick=1;
                    printm("\r\nDo you want a full menu? (Y/n) ");
                    if (*genin(1,0,1,1,YESNO)!='N') menus=0;
                    else menus=1;
                    if(menus) printm("\r\n? will redisplay full menu.\r\n");
                    break;
        case 'A':   graphics=1-graphics;
                    if (!graphics) printm("\r\n\x1b[0m\b \b\b \b\b \b\b \b");
                    break;
        case 'J':   printfm("\r\nThere are %u sections.\r\n",numsecs);
                    if (!quick) list_sections();
                    printm("\r\nNew Section name or #: ");
                    strcpy(s,genin(9,0,1,0,FLEW));
                    if(p=strchr(s,'.')) *p=0;
                    p=s;
                    if(!*p) {
                        printm("\r\n");
                        break;
                    }
                    x=(word)atol(p);
                    if (x<1 || x>numsecs) {

                        word matched=0;

                        x=0;
                        for(y=0;y<numsecs;y++) {
                            if(!stricmp(section[y],p)) {
                                matched++;
                                x=y+1;
                                break;
                            }
                        }
                        if(!matched) {
                            if (!strchr(p,'*') && !strchr(p,'?')) {
                                strcat(p,"*");
                                printm("*");
                            }
                            for(y=0;y<numsecs;y++) {

                                char temp;

                                if(name_match(p,section[y])) {
                                    matched++;
                                    printfm("\r\nJump to section #%u (%s)? (Y/n/q) ",y+1,section[y]);
                                    temp=*genin(1,0,1,1,YESNOQ);
                                    if(temp=='Q') {
                                        printm("\r\n");
                                        return 1;
                                    }
                                    if(temp!='N') {
                                        x=y+1;
                                        printm("\r\n");
                                        break;
                                    }
                                }
                            }
                            if(!x && matched) {
                                printm("\r\nNo more matching.\r\n");
                                break;
                            }
                        }
                        if(!x) {
                            printm("\r\n\r\nInvalid\r\n");
                            break;
                        }
                    }
                    printm("\r\n");
                    cursec = x - 1;
                    list_zoo(cursec,0,0,NULL);
                    break;
        case '<':
        case 'P':   if (cursec>0) {
                        cursec--;
                        list_zoo(cursec,0,0,NULL);
                    }
                    else printm("\x7");
                    break;
        case '>':
        case 'N':   if (cursec<(numsecs-1)) {
                        cursec++;
                        list_zoo(cursec,0,0,NULL);
                    }
                    else printm("\x7");
                    break;
        case 'L':   if (!full) {
                        list_zoo(cursec,1,0,NULL);
                    }
                    else quick_list();
                    break;
        case 'S':   if (!full) full_list(NULL);
                    else list_sections();
                    printm("\r\n");
                    break;
        case 'B':   printm("\r\n[A]ll sections? (y-N) ");
                    temp=toupper(*genin(1,0,1,1,YESNOQ));
                    printm("\r\n");
                    if(temp=='Q') break;
                    if(temp=='N' && !numfiles) {
                        printm("No documents available.\r\n");
                        break;
                    }
                    printfm("Enter keyword [%s]:\r\n-> ",keyword);
                    p=genin(76,0,1,1,ALLL);
                    printm("\r\n");
                    if(!*p) {
                        if(!*keyword) break;
                    }
                    else strcpy(keyword,p);
                    if(temp!='Y') {
                        list_zoo(cursec,1,0,keyword);
                    }
                    else {
                        full_list(keyword);
                        printm("\r\n");
                    }
                    break;
        case 'R':   if (!numfiles) {
                        printm("\r\nNo documents available.\r\n");
                        break;
                    }
                    if (numfiles == 1) {
                        readfile(0,cursec);
                        break;
                    }
                    if (*section[cursec] == '_' && !graphics) {
                        printm("\r\nANSI Graphics required.\r\n");
                        break;
                    }
                    if (!quick) quick_list();
                    printfm("\r\nRead which document name or # (1-%u)? ",numfiles);
                    strcpy(s,genin(13,0,1,0,FLEW));
                    p=s;
                    if(!*p) {
                        printm("\r\n");
                        break;
                    }
                    x=(word)atol(p);
                    if (x<1 || x>numfiles) {

                        word matched=0;

                        x=0;
                        for(y=0;y<numfiles;y++) {
                            if(!stricmp(p,document[y])) {
                                x=y+1;
                                matched++;
                                break;
                            }
                        }
                        if(!matched) {
                            if(!strchr(p,'*') && strchr(p,'?')) {
                                if(!strchr(p,'.')) {
                                    strcat(p,"*.*");
                                    printm("*.*");
                                }
                                else {
                                    strcat(p,"*");
                                    printm("*");
                                }
                            }
                            else {
                                if(!strchr(p,'.')) {
                                    strcat(p,"*");
                                    printm("*");
                                }
                            }
                            printm("\r\n");
                            for(y=0;y<numfiles;y++) {

                                char temp;

                                if(name_match(p,document[y])) {
                                    matched++;
                                    printfm("\r\nRead #%u (%s)? (Y/n/q) ",y+1,document[y]);
                                    temp=*genin(1,0,1,1,YESNOQ);
                                    if(temp=='Q') {
                                        printm("\r\n");
                                        return 1;
                                    }
                                    if(temp!='N') {
                                        printm("\r\n");
                                        readfile(y,cursec);
                                    }
                                }
                            }
                            if(matched) {
                                printm("\r\nNo more matching.\r\n");
                                break;
                            }
                        }
                        if(!x) {
                            printm("\r\n\r\nInvalid.\r\n");
                            break;
                        }
                    }
                    printm("\r\n");
                    readfile(x-1,cursec);
                    break;
        default:    return 0;
    }
    return 1;
}
